{* Read (and write) text in standard Pascal
   The code is due to Peter Tillier, 28 Oct 1988
   24 Kimbolton Close, LEE, London SE12 OJJ
   Thankfully acknowledged *}

program READWRIT (infile, output);

const maxstring = 79;

type StringLength = 0..maxstring;
     IndexType    = 1..maxstring;
     StringType   = array [ Indextype ] of char;
     
var infile : text;
    count  : StringLength;
    buffer : StringType;

procedure READSTRING ( var infile   : text;
                       var buffer   : StringType;
                       var numchars : StringLength );
var i : integer;

procedure ClearBuff ( var buff : StringType);
const space = ' ';
var i : integer;
begin
  for i := 1 to maxstring do buff[i] := space;
end;  { ClearBuff }

begin { ReadString }
  ClearBuff( buffer );
  i := 0;
  while not eof( infile ) and not eoln( infile ) do
    begin
      i := i + 1;
      buffer[ i ] := infile^;
      get ( infile );
    end; {while}
  if eoln( infile ) then get( infile );
  numchars := i;
end;  { ReadString }

procedure WRITESTRING (buffer : StringType;
                       count  : StringLength);
var i : StringLength;
begin
  i := 0;
  while (i < count) do
    begin
      i := i + 1;
      write (buffer[i]);
    end;
end;  {WriteString}

{* Main program *}
begin
  attach (infile, 'fdk1_test_dat');
  reset (infile);
  while not eof( infile ) do
    begin
      READSTRING (infile, buffer, count);
      WRITESTRING (buffer, count);
      writeln;
    end;
  close (infile);
end.
